import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker, Modal, Upload ,Popconfirm} from 'antd';
import PublicOrderDetaile from "./publicOrderDetaile.jsx";
import moment from 'moment';
import '../userMangagement.less';
import {lvl,intentProgress,transactionProgress,contractProgress,projectProgress} from '../../../dataDic.js';
import {getIntentProgress,getTransactionProgress,getContractProgress,getProjectProgress} from '../../../tools.js';
const PublicOrder=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/roles',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                customerName:this.state.customerName,
                startDate: this.state.releaseDate[0],
				endDate: this.state.releaseDate[1],
				transactionProgress:this.state.transactionProgress,
				contractProgress:this.state.contractProgress,
				projectProgress:this.state.projectProgress,
				settlementState:this.state.settlementState,
				orderStatus:this.state.orderStatus,
				approved:this.state.approved,
				orderChannel:this.state.orderChannel
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         roleName: thisdata.roleName,
	                         creater:thisdata.creater,
	                         createTime:thisdata.createTimez,
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[]
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            releaseDate: [],
            selectedRows: [],
            searchMore: true,
            loading: false,
            distributionVisible:false,
            visible:false,
            showDesc:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            distributionPagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.contactList(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'roleName',
                    key: 'roleName'
                }, {
                    title: '订单类型',
                    dataIndex: 'creater',
                    key: 'creater'
                }, {
                    title: '下单时间',
                    dataIndex: 'creater7',
                    key: 'creater7'
                },{
                    title: '订单客户',
                    dataIndex: 'roleName1',
                    key: 'roleName1'
                }, {
                    title: '订单金额',
                    dataIndex: 'c',
                    key: 'c'
                },
                {
                    title: '实际下单金额',
                    dataIndex: 'creater1',
                    key: 'creater1'
                }, {
                    title: '意向进度',
                    dataIndex: 'createTime1',
                    key: 'createTime1',
                    render:(text)=>{return getIntentProgress(text) }
                },{
                    title: '交易进度',
                    dataIndex: 'roleName2',
                    key: 'roleName2',
                    render:(text)=>{return getTransactionProgress(text) }
                }, {
                    title: '结算状态',
                    dataIndex: 'creater2',
                    key: 'creater2',
                    render:(text)=>{return getContractProgress(text) }
                }, {
                    title: '订单状态',
                    dataIndex: 'creatu',
                    key: 'creatu',
                    render:(text)=>{return getProjectProgress(text) }
                },{
                    title: '订单渠道',
                    dataIndex: 'cre',
                    key: 'cre',
                    render:(text)=>{return getProjectProgress(text) }
                },{
                    title: '操作',
                    dataIndex: 'operation',
                    key: 'operation',
                    render: (text, record, index) => {
						return <div>
							    	<Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation(),this.confirmDelet(record)}} type="primary">派单</Button>                 
                        	   </div>
					}
                }
            ],
            userList:[
            	{
                    title: '用户编号',
                    dataIndex: 'roleName',
                    key: 'roleName'
                }, {
                    title: '用户姓名',
                    dataIndex: 'creater',
                    key: 'creater'
                },{
                    title: '部门机构',
                    dataIndex: 'roleName1',
                    key: 'roleName1'
                }, {
                    title: '职务',
                    dataIndex: 'creater1',
                    key: 'creater1'
                },{
                    title: '联系手机',
                    dataIndex: 'roleName2',
                    key: 'roleName2'
                }, {
                    title: '操作',
                    dataIndex: 'abc',
                    key: 'abc',
                    render:(text,record,index)=>{
                    	return (
                    	    <Popconfirm title={'您确认将此订单 【'+ record.roleName+'】 分配给【'+record.roleName+'-'+record.roleName+'】进行业务跟进？'} onConfirm={(e)=>{this.confirmSelect(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} type="primary">选定</Button>                 
							</Popconfirm>
							)
                    }
                }
            ],
            dataSource: [],
        };
    },
    //操作分配
    confirmDelet(index){
    	this.setState({
    		userDetaile:false,
    		distributionVisible:true
    	});
    	this.contactList(1,index.id)
    },
    distributionCancel(){
    	this.setState({
    		distributionVisible:false
    	})
    },
    distributionOk(){
    	this.setState({
    		distributionVisible:false
    	})
    },
    //分配对象列表
    contactList(pageNo,orderId){
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/roles',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.distributionPagination.pageSize,
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         roleName: thisdata.roleName,
	                         creater:thisdata.creater,
	                         createTime:thisdata.createTimez,
	                         uid:orderId,
                        });
                    };
                    this.state.distributionPagination.current = data.data.pageNo;
                    this.state.distributionPagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.distributionPagination.current=0
					this.state.distributionPagination.total=0
				}
                this.setState({
                    distributionList: theArr,
                    pagination: this.state.distributionPagination,
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    //选定对象
    confirmSelect(record){
    	this.setState({
            loading: true
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "",
            data: {
            	id:record.id,
            	uid:record.uid
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('分配成功');
                this.setState({
                    loading: false,
                });
                this.distributionOk();
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData();
        }.bind(this));
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
            showDesc: true
        });
    },
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData();
        };
    },
    searchSwitch() {
		this.setState({
			searchMore: !this.state.searchMore
		});
	},
    search() {
        this.loadData();
    },
    //分配时搜索
    searchOrder() {
        this.contactList();
    },
    //分配时重置
    resetOrder() {
        this.contactList();
    },
    reset() {
    	this.state.customerName='';
    	this.state.releaseDate[0] = undefined;
		this.state.releaseDate[1] = undefined;
		this.state.transactionProgress = undefined;
		this.state.contractProgress = undefined;
		this.state.projectProgress = undefined;
		this.state.settlementState = undefined;
		this.state.orderStatus = undefined;
		this.state.approved = undefined;
		this.state.orderChannel = undefined;
        this.loadData();       
    },
    render() {
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>公共订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.customerName}
	                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} />
	                    <RangePicker
		                        value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
		                        this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
		                        onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />     
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索</Button>
	                    <Button onClick={this.reset}>重置</Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>                    			                  
	                        <Select placeholder="订单状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.orderStatus}
	                            onChange={(e) => { this.setState({ orderStatus: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="订单渠道"
	                            style={{ width: 150,marginRight:'10px' }}
	                            value={this.state.orderChannel}
	                            onChange={(e) => { this.setState({ orderChannel: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="订单类型"
	                            style={{ width: 150 }}
	                            value={this.state.orderChannel}
	                            onChange={(e) => { this.setState({ orderChannel: e }) }}>
	                            {
                                    lvl.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick} />
	                    </Spin>
	                </div>
	                <PublicOrderDetaile
	                	confirmDelet={this.confirmDelet}
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
	            <Modal maskClosable={false} visible={this.state.distributionVisible}
                        onOk={this.distributionOk} onCancel={this.distributionCancel}
                        width='800px'
                        title='分派订单'                     
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" onSubmit={this.handleSubmit} id="demand-form" style={{paddingBottom:'40px'}} >
			                <Spin spinning={this.state.loading}>
			                	<div>
			                		<Input placeholder="部门名称" style={{width:'150px'}}
				                        value={this.state.customerName}
				                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} />
				                    <Input placeholder="订单负责人" style={{width:'150px',marginLeft:'10px'}}
				                        value={this.state.customerName}
				                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} />  
				                    <Button type="primary" onClick={this.searchOrder} style={{marginLeft:'10px',marginRight:'10px'}}>搜索</Button>
	                    			<Button onClick={this.resetOrder}>重置</Button>
			                	</div>
			                	 <div className="patent-table" style={{marginTop:'10px'}}>
				                    <Spin spinning={this.state.loading}>
				                        <Table columns={this.state.userList}
				                            dataSource={this.state.distributionList}
				                            pagination={this.state.distributionPagination}
				                             />
				                    </Spin>
				                </div>
			                </Spin>
			            </Form>
			    </Modal>
            </div>
        );
    }
}));

export default PublicOrder;

